/*
Authorization Service API v. 1.0

<a href='https://cern.service-now.com/service-portal?id=privacy_policy&se=SSO-Service&notice=resources'>Privacy notice</a>

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package authzapiv1

import (
	"encoding/json"
)

// checks if the UserRoles type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &UserRoles{}

// UserRoles struct for UserRoles
type UserRoles struct {
	Roles           []Role `json:"roles,omitempty"`
	RolesMissingLoa []Role `json:"rolesMissingLoa,omitempty"`
	RolesMissingMfa []Role `json:"rolesMissingMfa,omitempty"`
}

// NewUserRoles instantiates a new UserRoles object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewUserRoles() *UserRoles {
	this := UserRoles{}
	return &this
}

// NewUserRolesWithDefaults instantiates a new UserRoles object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewUserRolesWithDefaults() *UserRoles {
	this := UserRoles{}
	return &this
}

// GetRoles returns the Roles field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *UserRoles) GetRoles() []Role {
	if o == nil {
		var ret []Role
		return ret
	}
	return o.Roles
}

// GetRolesOk returns a tuple with the Roles field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *UserRoles) GetRolesOk() ([]Role, bool) {
	if o == nil || IsNil(o.Roles) {
		return nil, false
	}
	return o.Roles, true
}

// HasRoles returns a boolean if a field has been set.
func (o *UserRoles) HasRoles() bool {
	if o != nil && !IsNil(o.Roles) {
		return true
	}

	return false
}

// SetRoles gets a reference to the given []Role and assigns it to the Roles field.
func (o *UserRoles) SetRoles(v []Role) {
	o.Roles = v
}

// GetRolesMissingLoa returns the RolesMissingLoa field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *UserRoles) GetRolesMissingLoa() []Role {
	if o == nil {
		var ret []Role
		return ret
	}
	return o.RolesMissingLoa
}

// GetRolesMissingLoaOk returns a tuple with the RolesMissingLoa field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *UserRoles) GetRolesMissingLoaOk() ([]Role, bool) {
	if o == nil || IsNil(o.RolesMissingLoa) {
		return nil, false
	}
	return o.RolesMissingLoa, true
}

// HasRolesMissingLoa returns a boolean if a field has been set.
func (o *UserRoles) HasRolesMissingLoa() bool {
	if o != nil && !IsNil(o.RolesMissingLoa) {
		return true
	}

	return false
}

// SetRolesMissingLoa gets a reference to the given []Role and assigns it to the RolesMissingLoa field.
func (o *UserRoles) SetRolesMissingLoa(v []Role) {
	o.RolesMissingLoa = v
}

// GetRolesMissingMfa returns the RolesMissingMfa field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *UserRoles) GetRolesMissingMfa() []Role {
	if o == nil {
		var ret []Role
		return ret
	}
	return o.RolesMissingMfa
}

// GetRolesMissingMfaOk returns a tuple with the RolesMissingMfa field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *UserRoles) GetRolesMissingMfaOk() ([]Role, bool) {
	if o == nil || IsNil(o.RolesMissingMfa) {
		return nil, false
	}
	return o.RolesMissingMfa, true
}

// HasRolesMissingMfa returns a boolean if a field has been set.
func (o *UserRoles) HasRolesMissingMfa() bool {
	if o != nil && !IsNil(o.RolesMissingMfa) {
		return true
	}

	return false
}

// SetRolesMissingMfa gets a reference to the given []Role and assigns it to the RolesMissingMfa field.
func (o *UserRoles) SetRolesMissingMfa(v []Role) {
	o.RolesMissingMfa = v
}

func (o UserRoles) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o UserRoles) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if o.Roles != nil {
		toSerialize["roles"] = o.Roles
	}
	if o.RolesMissingLoa != nil {
		toSerialize["rolesMissingLoa"] = o.RolesMissingLoa
	}
	if o.RolesMissingMfa != nil {
		toSerialize["rolesMissingMfa"] = o.RolesMissingMfa
	}
	return toSerialize, nil
}

type NullableUserRoles struct {
	value *UserRoles
	isSet bool
}

func (v NullableUserRoles) Get() *UserRoles {
	return v.value
}

func (v *NullableUserRoles) Set(val *UserRoles) {
	v.value = val
	v.isSet = true
}

func (v NullableUserRoles) IsSet() bool {
	return v.isSet
}

func (v *NullableUserRoles) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableUserRoles(val *UserRoles) *NullableUserRoles {
	return &NullableUserRoles{value: val, isSet: true}
}

func (v NullableUserRoles) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableUserRoles) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
